src/www/protected/models/Possession.php
<?php

/**
 * This is the model class for table "Partenaire_Titre".
 *
 * The followings are the available columns in table 'Partenaire_Titre':
 * @property int $partenaireId
 * @property int $titreId
 * @property string $identifiantLocal
 * @property string $bouquet
 *
 * @property Titre $titre
 * @property Partenaire $partenaire
 */
class Possession extends CActiveRecord
{
	public const IMPORT_ADDED = 1;

	public const IMPORT_NOCHANGE = 2;

	public const IMPORT_UPDATED = 3;

	public const IMPORT_DELETED = 4;

	public const IMPORT_NOTFOUND = 5;

	public const IMPORT_ERROR = 6;

	public const IMPORT_INSERT_NOTALLOWED = 7;

	public const IMPORT_UPDATE_NOTALLOWED = 8;

	public $overwrite = false;

	public static $codeMsgs = [
		self::IMPORT_NOTFOUND => "Suppression d'une possession inexistante",
		self::IMPORT_ERROR => "Erreur de validation / SQL",
		self::IMPORT_ADDED => "Ajout",
		self::IMPORT_NOCHANGE => "Aucun changement",
		self::IMPORT_UPDATED => "Mise à jour",
		self::IMPORT_DELETED => "Suppression",
		self::IMPORT_INSERT_NOTALLOWED => "Création non autorisée",
		self::IMPORT_UPDATE_NOTALLOWED => "Modification non autorisée",
	];

	/**
	 * Returns the static model of the specified AR class.
	 *
	 * @return Possession the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'Partenaire_Titre';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		return [
			['partenaireId, titreId', 'required'],
			['partenaireId, titreId', 'numerical', 'integerOnly' => true],
			['identifiantLocal, bouquet', 'length', 'max' => 255],
			['overwrite', 'boolean'],
			['partenaireId, titreId, identifiantLocal, bouquet', 'safe', 'on' => 'search'],
		];
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		return [
			'titre' => [self::BELONGS_TO, 'Titre', 'titreId'],
			'partenaire' => [self::BELONGS_TO, 'Partenaire', 'partenaireId'],
		];
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return [
			'partenaireId' => 'Partenaire',
			'titreId' => 'Titre',
			'identifiantLocal' => 'Identifiant Local',
			'bouquet' => 'Bouquet',
			'overwrite' => "Modification de l'existant",
		];
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * @param int|bool $pageSize Number of items for pagination (false to disable pagination).
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search($pageSize=25)
	{
		$criteria = new CDbCriteria;

		$criteria->compare('partenaireId', $this->partenaireId);
		$criteria->compare('titreId', $this->titreId);
		$criteria->compare('identifiantLocal', $this->identifiantLocal, true);
		$criteria->compare('bouquet', $this->bouquet, true);

		$sort = new CSort();
		$sort->attributes = ['partenaireId', 'titreId', 'identifiantLocal', 'bouquet'];
		//$sort->defaultOrder = 'id ASC';

		return new CActiveDataProvider(
			$this,
			[
				'criteria' => $criteria,
				'pagination' => ['pageSize' => $pageSize],
				'sort' => $sort,
			]
		);
	}

	public static function groupByBouquet($partenaireId)
	{
		return self::model()->with('titre')
			->findAllByAttributes(
				['partenaireId' => $partenaireId],
				['order' => 'bouquet ASC, titre.titre ASC']
			);
	}

	/**
	 * Imports this possession for a given Partenaire.
	 * @param bool $simulation
	 * @return int
	 */
	public function importAdd($simulation)
	{
		$existing = Possession::model()->findByAttributes(
			['partenaireId' => $this->partenaireId, 'titreId' => $this->titreId]
		);

		if (empty($existing)) {
			// INSERT
			$action = self::IMPORT_ADDED;
		} else {
			// UPDATE
			if (
				$existing->identifiantLocal == $this->identifiantLocal
				&& $existing->bouquet == $this->bouquet
			) {
				return self::IMPORT_NOCHANGE;
			}
			if (!$this->overwrite) {
				return self::IMPORT_UPDATE_NOTALLOWED;
			}
			$this->setIsNewRecord(false);
			$action = self::IMPORT_UPDATED;
		}
		if (!$simulation) {
			if (!$this->save()) {
				return self::IMPORT_ERROR;
			}
		}
		return $action;
	}

	/**
	 * Deletes this possession for a given Partenaire.
	 * @param bool $simulation
	 * @return int
	 */
	public function importDelete($simulation)
	{
		$existing = Possession::model()->findByAttributes(
			['partenaireId' => $this->partenaireId, 'titreId' => $this->titreId]
		);

		if (empty($existing)) {
			return self::IMPORT_NOTFOUND;
		}
		if (!$simulation) {
			if ($existing->delete() != 1) {
				return self::IMPORT_ERROR;
			}
		}
		return self::IMPORT_DELETED;
	}

	public static function getMsgFromCode($code)
	{
		if (!isset(self::$codeMsgs[$code])) {
			return '';
		}
		return self::$codeMsgs[$code];
	}
}

src/www/protected/controllers/PossessionController.php
<?php

class PossessionController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout = '//layouts/column2';

	//public $defaultAction = 'admin';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return [
			'accessControl', // perform access control for CRUD operations
		];
	}

	/**
	 * Specifies the access control rules.
	 *
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return [
			[
				'allow',
				'users' => ['@'],
			],
			[
				'deny',  // deny all users
				'users' => ['*'],
			],
		];
	}

	/**
	 * Exports to CSV.
	 *
	 * @param int $partenaireId
	 */
	public function actionExport($partenaireId)
	{
		$partenaire = Partenaire::model()->findByPk($partenaireId);
		if (!$partenaire) {
			throw new CHttpException(404, "Ce partenaire n'existe pas.");
		}
		if (!Yii::app()->user->checkAccess('possession/update', ['Partenaire' => $partenaire])) {
			throw new CHttpException(403, "Vous n'avez pas la permission de gérer ces possessions.");
		}
		$sql = "SELECT 1, pt.bouquet, t.titre, t.id, i1.issn, i2.issn AS issne, IF(i1.issnl <> '', i1.issnl, i2.issnl) AS issnl, t.revueId, pt.identifiantLocal "
			. "FROM Partenaire_Titre pt JOIN Titre t ON pt.titreId = t.id"
			. " LEFT JOIN Issn i1 ON (i1.titreId = t.id AND i1.support = 'papier') "
			. " LEFT JOIN Issn i2 ON (i2.titreId = t.id AND i2.support = 'electronique') "
			. "WHERE pt.partenaireId = " . (int) $partenaireId
			. " ORDER BY pt.bouquet ASC, t.titre ASC";
		$cmd = Yii::app()->db->createCommand($sql);
		$this->header("csv");
		header('Content-Disposition: inline; filename=Mirabel_possessions_' . date('Y-m-d') . '.csv');
		$out = fopen('php://output', 'w');
		fputcsv($out, PossessionImport::$columns, ';');
		foreach ($cmd->queryAll(false) as $row) {
			fputcsv($out, $row, ';');
		}
	}

	public function actionExportMore($partenaireId)
	{
		$partenaire = Partenaire::model()->findByPk($partenaireId);
		if (!$partenaire) {
			throw new CHttpException(404, "Ce partenaire n'existe pas.");
		}
		if (!Yii::app()->user->checkAccess('possession/update', ['Partenaire' => $partenaire])) {
			throw new CHttpException(403, "Vous n'avez pas la permission de gérer ces possessions.");
		}

		$this->header('csv');
		header(sprintf('Content-disposition: attachment;filename=Mirabel_possessions-ext_%s.csv', date('Y-m-d')));
		$exporter = new models\exporters\Titre();
		$exporter->partenaireId = (int) $partenaire->id;
		$exporter->possessionsToCsv(";");
		exit(0);
	}

	/**
	 * Imports from CSV.
	 *
	 * @param int $partenaireId
	 */
	public function actionImport($partenaireId)
	{
		$partenaire = Partenaire::model()->findByPk($partenaireId);
		if (!$partenaire) {
			throw new CHttpException(404, "Ce partenaire n'existe pas.");
		}
		if (!Yii::app()->user->checkAccess('possession/update', ['Partenaire' => $partenaire])) {
			throw new CHttpException(403, "Vous n'avez pas la permission de gérer ces possessions.");
		}

		$model = new PossessionImport;
		$model->partenaireId = $partenaireId;

		if (isset($_POST['PossessionImport'])) {
			$model->attributes = $_POST['PossessionImport'];
			$model->importfile = CUploadedFile::getInstance($model, 'importfile');
			if ($model->validate()) {
				try {
					$model->import($model->importfile->tempName);
				} catch (Exception $e) {
					$model->addError('importfile', $e->getMessage());
				}
			}
		}

		$this->render(
			'import',
			['model' => $model, 'partenaire' => $partenaire]
		);
	}
}

src/www/protected/views/possession/import.php
<?php

/** @var Controller $this */
/** @var Partenaire $partenaire */
/** @var PossessionImport $model */
assert($this instanceof Controller);

$this->pageTitle = Yii::app()->name . ' - Import CSV des possessions';
$this->breadcrumbs = [
	$partenaire->nom => ['/partenaire/view', 'id' => $partenaire->id],
	'Import CSV des possessions',
];

$this->menu = [
	['label' => 'Retour à ce partenaire', 'url' => ['/partenaire/view', 'id' => $partenaire->id]],
	['label' => ''],
	['label' => 'Liste des partenaires', 'url' => ['/partenaire/index']],
	['label' => ''],
	['label' => 'Possessions', 'itemOptions' => ['class' => 'nav-header']],
	['label' => 'Gestion des titres', 'url' => ['/partenaire/possession', 'id' => $partenaire->id]],
	['label' => 'Export CSV', 'url' => ['/possession/export', 'partenaireId' => $partenaire->id]],
];
?>

<h1>Importer des possessions : <?php echo CHtml::encode($partenaire->getFullName()); ?></h1>

<?php
if ($model->importedRows) {
	?>
	<ul>
		<?php
		if ($model->simulation) {
			echo "<li>Mode de simulation : <strong>aucune action n'est enregistrée</strong>.</li>";
		} ?>
		<li>
			Pour modifier cet import de possessions, vous pouvez télécharger le CSV de ce
			<?= CHtml::link("tableau des résultats", "#", ['class' => 'btn btn-info btn-small', 'onclick' => 'exportResults(this)']) ?>,
			<em>supprimer les trois dernières colonnes</em>,
			puis l'importer à nouveau.
		</li>
		<li>
			<button type="button" id="toggle-success-rows" class="btn btn-primary btn-small">Afficher/masquer les lignes sans problème</button>
		</li>
	</ul>
	<table class="table table-striped table-bordered table-condensed exportable" id="imported-rows">
		<thead>
			<th>possession</th>
			<th>bouquet</th>
			<th>titre</th>
			<th>titre ID</th>
			<th>issn</th>
			<th>issne</th>
			<th>issnl</th>
			<th>revue ID</th>
			<th>identifiant local</th>
			<th>statut/possession</th>
			<th>titre Mir@bel</th>
			<th>lien</th>
		<tbody>
		<?php
		foreach ($model->importedRows as $row) {
			$titreId = $row[3];
			$status = $row['status']; ?>
			<tr class="<?= $status ?>">
				<?php
				for ($i = 0; $i < 8; $i++) {
					echo CHtml::tag('td', [], $row[$i]);
				} ?>
				<td><?= CHtml::encode($row['message']) ?></td>
				<td><?= CHtml::encode($row['titre M']) ?></td>
				<td><?= $titreId ? CHtml::link("→", ['/titre/view', 'id' => $titreId]) : "" ?></td>
			</tr>
			<?php
		} ?>
		</tbody>
	</table>
	<?php
	$today = date('Y-m-d');
	Yii::app()->clientScript->registerScript(
		'toggle-success-rows',
		<<<EOJS
			$("#toggle-success-rows").on('click', function() {
				$("#imported-rows").toggleClass('hide-success');
			});
			window.exportResults = function (e) {
				exportTableToCSV.apply(e, [$("#imported-rows"), "Mirabel_possessions_import_{$today}.csv"]);
			}
			EOJS
	);
}
?>

<?php
$form = $this->beginWidget(
	'BootActiveForm',
	[
		'id' => 'import-form',
		'type' => 'horizontal',
		'enableClientValidation' => false,
		'hints' => Hint::model()->getMessages("PossessionImport"),
		'htmlOptions' => ['enctype' => 'multipart/form-data'],
	]
);
/** @var BootActiveForm $form */

echo $form->errorSummary($model);

echo $form->fileFieldRow($model, 'importfile', ['errorOptions' => ['class' => 'hidden']]);
echo $form->textFieldRow($model, 'separator', ['class' => 'span1']);
echo $form->checkBoxRow($model, 'overwrite', ['label-position' => 'left']);
echo $form->checkBoxRow($model, 'simulation', ['label-position' => 'left']);
?>

<div class="form-actions">
	<?php echo CHtml::htmlButton('Importer', ['class' => 'btn', 'type' => 'submit']); ?>
</div>

<?php $this->endWidget(); ?>

<h3>Instructions</h3>
<ul>
	<li>
		Pour modifier l'ensemble de vos possessions, vous pouvez importer le
		<?= CHtml::link("tableau de vos possessions", ['possession/export', 'partenaireId' => $partenaire->id], ['class' => 'btn btn-info btn-small']) ?>
	</li>
	<li>
		Le fichier déposé doit suivre le format du fichier CSV d'export.
		Par exemple, télécharger ce <?= CHtml::link("modèle de fichier CSV", Yii::app()->baseUrl . '/public/mirabel_possession.csv', ['class' => 'btn btn-info btn-small']) ?>
		puis modifier le contenu, et enfin déposer le CSV obtenu dans le formulaire en haut de page.
		Les colonnes de ce CSV sont :
		<dl>
			<dt>possession</dt><dd>1 pour ajouter cette revue, 0 pour la retirer si la case de modification est cochée<dd>
			<dt>bouquet</dt><dd>Permet de regrouper les possessions en bouquets<dd>
			<dt>titre</dt><dd>inutilisé<dd>
			<dt>titre ID</dt><dd>L'identifiant numérique du titre dans Mir@bel, visible dans les exports ou dans l'URL d'une page titre (détail par titre d'une revue)<dd>
			<dt>issn</dt><dd>Un ISSN ou ISSN-E de la possession<dd>
			<dt>issne</dt><dd>Un ISSN ou ISSN-E de la possession<dd>
			<dt>issnl</dt><dd>Un ISSN-L de la possession<dd>
			<dt>revue ID</dt><dd>L'identifiant numérique de la revue dans Mir@bel, visible dans les exports ou dans l'URL d'une page revue (page principale)<dd>
			<dt>identifiant local</dt><dd>L'identifiant de la possession dans votre base de données.<dd>
		</dl>
	</li>
	<li>La première ligne sera ignorée, elle contient normalement les titres des colonnes.</li>
	<li>
		Un titre sera identifié par <code>titre ID</code>, <code>issn</code>, <code>issnl</code>, et evéntuellement <code>revue ID</code>.
		À chaque ligne CSV, au moins un de ces champs doit être rempli.
	</li>
	<li>
		Par défaut, les modifications des possessions ne sont pas activées ;
		on ne peut changer l'identifiant local ou le nom du bouquet
		qu'en cochant la case "Modification de l'existant".
	</li>
	<li>
		<p>Après l'envoi du formulaire, un récapitulatif des actions effectuées sera affiché.</p>
		<table class="table table-striped table-bordered table-condensed" style="max-width: 70ex;">
			<thead><th>Légende</th></thead>
			<tbody>
				<tr class="action"><td>Changement effectif</td></tr>
				<tr><td>Pas de changement</td></tr>
				<tr class="warning"><td>Modification non appliquée (refusée)</td></tr>
				<tr class="error"><td>Erreur, données incorrectes ou problème de base de données</td></tr>
			<tbody>
		</table>
	</li>
</ul>